<?php


abstract class BackModuleSelection extends BackModule
{
    protected $customTable;

    protected $selectionType;

    public function create($formvars = [], $table = null, $langue = true)
    {
        $formvars["selection_type"] = $this->selectionType;
        $formvars["{$this->customTable}_id"] = $idSelection = parent::create_multi($formvars, $table, $langue);
        if(!empty($idSelection)){
            Boutique::getInstance()->createStatut("selection", $idSelection);
            parent::create($formvars, $this->customTable, $langue);
        }

        return $idSelection;
    }

    public function createSpec($formvars = [], $table = null, $langue = null)
    {
        return parent::create($formvars, $table, $langue);
    }

    public function createSpecMulti($formvars = [], $table = null, $langue = null)
    {
        return parent::create_multi($formvars, $table, $langue);
    }

    public function update($formvars = array(), $table = null, $langue = true)
    {
        $formvars["selection_type"] = $this->selectionType;
        parent::update_multi($formvars, $table, $langue);

        $formvars["{$this->customTable}_id"] = $formvars['back_id'];
        parent::update($formvars, $this->customTable, $langue);
    }

    public function updateSpec($formvars = [], $table = null, $langue = null)
    {
        parent::update($formvars, $table, $langue);
    }

    public function updateSpecMulti($formvars = [], $table = null, $langue = null)
    {
        parent::update_multi($formvars, $table, $langue);
    }

    public function Form($formvars = []) : string
    {
        // SQL
        if (!empty($formvars['id'])) {
            $sql = "
                SELECT *
                FROM selection s 
                LEFT JOIN selection_nom sn ON (
                    sn.selection_id = s.selection_id
                    AND sn.langue_id =" . LANGUE . "
                )
                LEFT JOIN {$this->customTable} ct ON (
                    ct.{$this->customTable}_id = s.selection_id
                )
                WHERE s.selection_id ={$formvars['id']}
            ";

            $this->request = $sql;
        } else {
            $formvars['id'] = 0;
        }
        //-- SQL
        $this->addMainGroup();

        $form = new BackForm("Boutiques", "group");
        $form->addGroupOpts('class', 'selection_boutique');
        $this->addForm($form);

        $this->addSecondaryGroup();

        return $this->displayForm($formvars['id']);
    }

    protected function addMainGroup()
    {
        $form = new BackForm("Informations principales", "group");
        $this->addForm($form);

        $form = new BackForm("Parent", "select", "parent_id");
        $form->addOption("NULL", "---");
        $form->addOptionSQL("
            SELECT s.selection_id, sn.selection_nom_nom
            FROM selection s
            LEFT JOIN selection_nom sn ON (
                sn.selection_id = s.selection_id
                AND sn.langue_id =" . LANGUE . "
            )
            LEFT JOIN {$this->customTable} ct ON (
                ct.{$this->customTable}_id = s.selection_id
            )
            WHERE s.selection_type = '{$this->selectionType}'
        ");
        $this->addForm($form);

        $form = new BackForm("Nom", "text", "selection_nom_nom");
        $form->setVar('translate', true);
        $form->addAttr('class', 'required');
        $this->addForm($form);

        $form = new BackForm("Rang", "text", "selection_rang");
        $form->addAttr('class', 'required');
        $this->addForm($form);
    }

    protected function addSecondaryGroup()
    {
        //GROUP
        $form = new BackForm("Informations secondaires", "group");
        $this->addForm($form);
        //--GROUP

        $form = new BackForm("Image", "image", "selection_image");
        $this->addForm($form);

        $form = new BackForm("Description", "tinymce", "selection_nom_desc");
        $form->setVar('translate', true);
        $this->addForm($form);
        //-- Champs du formulaire
    }
}
