<?php

class bCategorie extends BackModuleSelection
{
    protected $customTable = "categorie_spec";

    protected $selectionType = CategorieSpec::SELECTION_TYPE;

    /**
     * @param array $formvars
     * @param null $table
     * @param bool $langue
     * @return mixed
     * @throws DediException
     */
    public function create($formvars = [], $table = null, $langue = true)
    {
        $formvars["selection_type"] = $this->selectionType;
        $formvars["categorie_id"] = $idSelection = parent::createSpecMulti($formvars, $table, $langue);
        if(!empty($idSelection)){
            Boutique::getInstance()->createStatut("selection", $idSelection);
            parent::createSpec($formvars, $this->customTable, $langue);
        }

        if(!empty($idSelection)){
            $categorieSpec = new CategorieSpec();
            $categorieSpec->updateExtId($idSelection);
        }
        return $idSelection;
    }

    /**
     * @param array $formvars
     * @param null $table
     * @param bool $langue
     * @throws DediException
     */
    public function update($formvars = array(), $table = null, $langue = true)
    {
        $formvars["selection_type"] = $this->customTable;
        parent::updateSpecMulti($formvars, $table, $langue);

        $formvars["categorie_id"] = $formvars['back_id'];
        parent::updateSpec($formvars, $this->customTable, $langue);

        $categorieSpec = new CategorieSpec();
        $categorieSpec->updateExtId($formvars['back_id']);
    }

    /**
     * @param array $formvars
     * @return array|string
     * @throws Exception
     */
    function Listing($formvars = array()) : string
    {
        // RECHERCHE
        $form = new BackForm("Cat&eacute;gorie", "select", "s.parent_id");
        $form->addOption("", "---");
        $form->addOptionSQL("
            SELECT s.selection_id, sn.selection_nom_nom
            FROM selection s
            LEFT JOIN selection_nom sn ON (
                sn.selection_id = s.selection_id
                AND sn.langue_id = " . LANGUE . "
            )
            WHERE s.selection_type = '".$this->selectionType."'
        ");
        $this->addForm($form);
        //-- RECHERCHE

        // SQL
        $sql = "
            SELECT 
                s.selection_id, 
                s.selection_id, 
                sn.selection_nom_nom,
                CONCAT(COUNT(DISTINCT ps.produit_id), ' article(s)'),
                s.selection_rang,
                COUNT(DISTINCT cenf.categorie_id)
            FROM (selection s)
            INNER JOIN categorie c ON (
                c.categorie_id = s.selection_id
            )
            LEFT JOIN selection_nom sn ON (
                s.selection_id = sn.selection_id
                AND sn.langue_id = '" . LANGUE . "' 
            )
            LEFT JOIN selection senf ON (
                senf.parent_id = s.selection_id
            )
            LEFT JOIN categorie cenf ON (
                cenf.categorie_id = senf.selection_id
            )
            LEFT JOIN produit_selection ps ON (
                ps.selection_id = s.selection_id 
                OR senf.selection_id = ps.selection_id
            )
            WHERE s.selection_type = '{$this->selectionType}'
        ";

        if (!isset($_GET['s*parent_id']) || empty($_GET['s*parent_id']) || $_GET['s*parent_id'] == 'NULL')
            $sql .= " AND s.parent_id IS NULL";

        $this->request = $sql;
        //-- SQL
        // LABELS
        $label = new BackLabel("ID");
        $this->addLabel($label);

        $label = new BackLabel("NOM");
        $this->addLabel($label);

        $label = new BackLabel("NB PRODUIT");
        $this->addLabel($label);

        $label = new BackLabel("RANG");
        $this->addLabel($label);

        $label = new BackLabel("SOUS-CATEGORIES", "listselect");
        $label->setVar('option', array("module" => "<a href='../../categorie/list/?s*parent_id=%ID%'>%IMG%</a>"));
        $this->addLabel($label);
        //-- LABELS

        return $this->displayList($formvars['type']);
    }

    /**
     * @param array $formvars
     * @return string
     * @throws Exception
     */
    public function Form($formvars = []) : string
    {
        // SQL
        if (!empty($formvars['id'])) {
            $sql = "
                SELECT *
                FROM selection s 
                LEFT JOIN selection_nom sn ON (
                    sn.selection_id = s.selection_id
                    AND sn.langue_id =".LANGUE."
                )
                LEFT JOIN {$this->customTable} ct ON (
                    ct.categorie_id = s.selection_id
                )
                WHERE s.selection_id ={$formvars['id']}
            ";
            $this->request = $sql;
        } else {
            $formvars['id'] = 0;
        }
        //-- SQL
        $this->addMainGroup();

        $form = new BackForm("Boutiques", "group");
        $form->addGroupOpts('class', 'selection_boutique');
        $this->addForm($form);

        $this->addSecondaryGroup();

        return $this->displayForm($formvars['id']);
    }

    /**
     * @throws Exception
     */
    protected function addMainGroup()
    {
        $form = new BackForm("Informations principales", "group");
        $this->addForm($form);

        $form = new BackForm("Parent", "select", "parent_id");
        $form->addOption("NULL", "---");
        $form->addOptionSQL("
            SELECT s.selection_id, sn.selection_nom_nom
            FROM selection s 
            LEFT JOIN selection_nom sn ON (
                sn.selection_id = s.selection_id
                AND sn.langue_id =".LANGUE."
               )
            LEFT JOIN {$this->customTable} ct ON (
                ct.categorie_id = s.selection_id
            )
            WHERE s.selection_type ='{$this->selectionType}'
        ");
        $this->addForm($form);

        $form = new BackForm("Nom", "text", "selection_nom_nom");
        $form->setVar('translate', true);
        $form->addAttr('class', 'required');
        $this->addForm($form);

        $form = new BackForm("Rang", "text", "selection_rang");
        $form->addAttr('class', 'required');
        $this->addForm($form);
    }

    protected function addSecondaryGroup()
    {
        //GROUP
        $form = new BackForm("Informations secondaires", "group");
        $this->addForm($form);
        //--GROUP

        $form = new BackForm("Image", "image", "selection_image");
        $this->addForm($form);

        $form = new BackForm("Image Listing", "image", "categorie_image_listing");
        $this->addForm($form);

        $form = new BackForm("Description", "tinymce", "selection_nom_desc");
        $form->setVar('translate', true);
        $this->addForm($form);
    }
}
