<?php


class bGamme extends BackModuleSelection
{
    /** @var string  */
    protected $customTable = "gamme";

    /** @var string */
    protected $selectionType = Gamme::SELECTION_TYPE;

    /** @var Gamme */
    protected $gamme;

    public function __construct($formvars = array())
    {
        parent::__construct($formvars);
        $this->gamme = new Gamme();
    }

    /**
     * @param array $formvars
     * @param null $table
     * @param bool $langue
     * @return mixed
     * @throws DediException
     */
    public function create($formvars = [], $table = null, $langue = true)
    {
        $id = parent::create($formvars, $table, $langue);

        if(!empty($id)){
            $this->gamme->updateExtId($id);
        }

        return $id;
    }

    /**
     * @param array $formvars
     * @param null $table
     * @param bool $langue
     * @throws DediException
     */
    public function update($formvars = array(), $table = null, $langue = true)
    {
        parent::update($formvars, $table, $langue);
        $this->gamme->updateExtId($formvars['back_id']);
    }

    /**
     * @param array $formvars
     * @return string
     * @throws Exception
     */
    function Listing($formvars = array()): string
    {
        // RECHERCHE
        $form = new BackForm("Gamme", "select", "s.parent_id");
        $form->addOption("", "---");
        $form->addOptionSQL("
            SELECT s.selection_id, sn.selection_nom_nom
                FROM selection s 
                LEFT JOIN selection_nom sn ON (
                    sn.selection_id = s.selection_id
                    AND sn.langue_id =" . LANGUE . "
                   )
                WHERE s.selection_type ='{$this->selectionType}'
            ");
        $this->addForm($form);
        //-- RECHERCHE

        // SQL
        $sql = "
            SELECT 
                s.selection_id, s.selection_id, sn.selection_nom_nom,
                CONCAT(COUNT(DISTINCT ps.produit_id), ' article(s)'),
                s.selection_rang,
                COUNT(DISTINCT genf.gamme_id)
            FROM (selection s)
            INNER JOIN gamme g ON (
                g.gamme_id = s.selection_id
            )
            LEFT JOIN selection_nom sn ON (
                s.selection_id = sn.selection_id
                AND sn.langue_id = '" . LANGUE . "'
            )
            LEFT JOIN selection senf ON (
                senf.parent_id = s.selection_id
            )
            LEFT JOIN gamme genf ON (
                genf.gamme_id = senf.selection_id
            )
            LEFT JOIN produit_selection ps ON (
                ps.selection_id = s.selection_id OR senf.selection_id = ps.selection_id
            )
            WHERE s.selection_type = '{$this->selectionType}'";

        if (!isset($_GET['s*parent_id']) || empty($_GET['s*parent_id']) || $_GET['s*parent_id'] == 'NULL')
            $sql .= " AND s.parent_id IS NULL";

        $this->request = $sql;
        //-- SQL
        // LABELS
        $label = new BackLabel("ID");
        $this->addLabel($label);

        $label = new BackLabel("NOM");
        $this->addLabel($label);

        $label = new BackLabel("NB PRODUIT");
        $this->addLabel($label);

        $label = new BackLabel("RANG");
        $this->addLabel($label);

        $label = new BackLabel("SOUS-GAMMES", "listselect");
        $label->setVar('option', array("module" => "<a href='../../gamme/list/?s*parent_id=%ID%'>%IMG%</a>"));
        $this->addLabel($label);
        //-- LABELS

        return $this->displayList($formvars['type']);
    }

    protected function addMainGroup()
    {
        $form = new BackForm("Informations principales", "group");
        $this->addForm($form);

        $form = new BackForm("Parent", "select", "parent_id");
        $form->addOption("NULL", "---");
        $form->addOptionSQL("
            SELECT s.selection_id, sn.selection_nom_nom
            FROM selection s 
            LEFT JOIN selection_nom sn ON (
                sn.selection_id = s.selection_id
                AND sn.langue_id =".LANGUE."
            )
            LEFT JOIN {$this->customTable} ct ON (
                ct.{$this->customTable}_id = s.selection_id
            )
            WHERE s.selection_type ='{$this->selectionType}'
        ");
        $this->addForm($form);

        $form = new BackForm("Nom", "text", "selection_nom_nom");
        $form->setVar('translate', true);
        $form->addAttr('class', 'required');
        $this->addForm($form);

        $form = new BackForm("Couleur", "text", "gamme_couleur");
        $this->addForm($form);

        $form = new BackForm("Rang", "text", "selection_rang");
        $form->addAttr('class', 'required');
        $this->addForm($form);
    }
}
