<?php


abstract class bProduit_selection extends BackModule
{
    /** @var string */
    protected $selectionType;

    /** @var string */
    protected $inputName;

    public function update($formvars = array(), $table = null, $langue = true)
    {

        $return = parent::update($formvars, $table, $langue);

        if (!isset($formvars['back_default']))
            $formvars['back_default'] = "";
        $this->setDefault($this->bases[0], 'produit', $formvars['back_id'], $formvars['back_default']);

        return $return;
    }

    public function create($formvars = array(), $table = null, $langue = true)
    {

        $return = parent::create($formvars, $table, $langue);

        if (empty($formvars['back_default'])) {
            $formvars['back_default'] = "";
        }
        $this->setDefault($this->bases[0], 'produit', $return, $formvars['back_default']);

        return $return;
    }

    public function delete($formvars = array())
    {
        $zeID = $this->getValue($this->bases[0], 'produit_id', $this->bases[0] . '_id', $formvars['back_id']);
        $return = parent::delete($formvars);

        $this->setDefault($this->bases[0], 'produit', $zeID, NULL);

        return $return;
    }

    public function Form($formvars = array())
    {
        // SQL
        if (!empty($formvars['id'])) {
            $this->request = getTable('produit_selection', $formvars['id']);
        }
        //-- SQL
        // Champs du formulaire
        $form = new BackForm("Produit ID", "hidden", "produit_id");
        $this->addForm($form);

        $form = new BackForm($this->inputName, "select", "selection_id");
        $form->addAttr('class', 'required');
        $form->addOption("NULL", "---");

        $query = new Query();
        $query->select("s.selection_id, sn.selection_nom_nom")
            ->from("selection s")
            ->leftJoin("selection_nom sn", "AND", ["sn.selection_id", "s.selection_id"], ["sn.langue_id", LANGUE])
            ->where("s.selection_type", $this->selectionType);
        $form->addOptionSQL([$query->build()]);
        $this->addForm($form);

        $form = new BackForm("Par d&eacute;faut", "checkbox", "back_default");
        $this->addForm($form);
        //-- Champs du formulaire

        if (!isset($formvars['id']))
            $formvars['id'] = 0;
        return $this->displayForm($formvars['id'], $formvars['div']);
    }

    public function Listing($formvars = array())
    {

        // SQL
        $sql = "SELECT ps.produit_selection_id";
        $sql .= ", ps.produit_selection_id";
        $sql .= ", IF(spar.selection_id IS NOT NULL, CONCAT(IF(sparn2.selection_id IS NOT NULL, CONCAT(sparn2.selection_nom_nom, ' > '),''), sparn.selection_nom_nom, ' > ', sn.selection_nom_nom),  sn.selection_nom_nom)";
        $sql .= ", ps.produit_selection_default";
        $sql .= " FROM (produit_selection ps)";
        $sql .= " LEFT JOIN selection s ON (s.selection_id = ps.selection_id)";
        $sql .= " LEFT JOIN selection_nom sn ON (sn.selection_id = s.selection_id AND sn.langue_id='" . LANGUE . "')";
        $sql .= " LEFT JOIN selection spar ON (spar.selection_id = s.parent_id)";
        $sql .= " LEFT JOIN selection_nom sparn ON (sparn.selection_id = spar.selection_id AND sparn.langue_id='" . LANGUE . "')";
        $sql .= " LEFT JOIN selection_nom sparn2 ON (sparn2.selection_id = spar.parent_id AND sparn2.langue_id='" . LANGUE . "')";
        $sql .= " WHERE 1";

        $sql .= " AND s.selection_type = '{$this->selectionType}'";

        if (!empty($formvars['produit']))
            $sql .= " AND ps.produit_id = '" . $formvars['produit'] . "'";

        $this->request = $sql;
        //-- SQL
        // LABELS
        $label = new BackLabel("ID");
        $this->addLabel($label);

        $label = new BackLabel("NOM");
        $this->addLabel($label);

        $label = new BackLabel("DEFAUT", 'default');
        $this->addLabel($label);
        //-- LABELS

        return $this->displayList($formvars['type']);
    }
}