<?php

use Phinx\Migration\AbstractMigration;

class AlterCategorieForSelection extends AbstractMigration
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-abstractmigration-class
     *
     * The following commands can be used in this method and Phinx will
     * automatically reverse them when rolling back:
     *
     *    createTable
     *    renameTable
     *    addColumn
     *    addCustomColumn
     *    renameColumn
     *    addIndex
     *    addForeignKey
     *
     * Any other destructive changes will result in an error when trying to
     * rollback the migration.
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
    public function change()
    {
        $this->table("categorie")
            ->dropForeignKey(["parent_id"])
            ->update();

        $this->table("categorie")
            ->removeColumn("parent_id")
            ->removeColumn("categorie_rang")
            ->removeColumn("categorie_date_ajout")
            ->removeColumn("categorie_date_modif")
            ->removeColumn("categorie_image")
            ->removeColumn("categorie_ext_id")
            ->addForeignKey("categorie_id", "selection", "selection_id",
                [
                    "delete" => "CASCADE",
                    "update" => "CASCADE"
                ])
            ->update();
    }
}
