<?php

use Phinx\Migration\AbstractMigration;

class AddCategorieView extends AbstractMigration
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-abstractmigration-class
     *
     * The following commands can be used in this method and Phinx will
     * automatically reverse them when rolling back:
     *
     *    createTable
     *    renameTable
     *    addColumn
     *    addCustomColumn
     *    renameColumn
     *    addIndex
     *    addForeignKey
     *
     * Any other destructive changes will result in an error when trying to
     * rollback the migration.
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
    public function up()
    {
        $this->execute("
        CREATE OR REPLACE VIEW categorie AS
        SELECT selection_id         as categorie_id,
               parent_id,
               selection_image      as categorie_image,
               selection_rang       as categorie_rang,
               selection_date_ajout as categorie_date_ajout,
               selection_date_modif as categorie_date_modif,
               selection_ext_id     as categorie_ext_id
        FROM selection
        WHERE selection_type = 'categorie';
        
        CREATE OR REPLACE VIEW categorie_boutique AS
        SELECT sb.selection_boutique_id        as categorie_boutique_id,
               sb.selection_id                 as categorie_id,
               sb.boutique_id,
               sb.selection_boutique_statut_id as categorie_boutique_statut_id
        FROM selection_boutique sb
                 INNER JOIN selection s on sb.selection_id = s.selection_id AND s.selection_type = 'categorie';
        
        CREATE OR REPLACE VIEW categorie_nom AS
        SELECT sn.selection_nom_id   as categorie_nom_id,
               sn.selection_id       as categorie_id,
               sn.langue_id,
               sn.selection_nom_nom  as categorie_nom_nom,
               sn.selection_nom_desc as categorie_nom_desc
        FROM selection_nom sn
                 INNER JOIN selection s on sn.selection_id = s.selection_id AND s.selection_type = 'categorie';
        ");
    }

    public function down()
    {
        $this->execute("DROP VIEW categorie_nom");
        $this->execute("DROP VIEW categorie_boutique");
        $this->execute("DROP VIEW categorie");
    }
}
