<?php

use Phinx\Migration\AbstractMigration;

class InsertProduitGammeBackModule extends AbstractMigration
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-abstractmigration-class
     *
     * The following commands can be used in this method and Phinx will
     * automatically reverse them when rolling back:
     *
     *    createTable
     *    renameTable
     *    addColumn
     *    addCustomColumn
     *    renameColumn
     *    addIndex
     *    addForeignKey
     *
     * Any other destructive changes will result in an error when trying to
     * rollback the migration.
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
    public function up()
    {
        $data = [
            "module_parent_id" => 101, // Catalogue
            "module_nom" => "Gestion des Produits Gammes",
            "module_titre" => "Produit Gamme",
            "module_page" => "produit_gamme",
            "module_rang" => "65",
            "actif_id" => "2",
            "module_order" => "-2",
            "module_bases" => "produit_selection",
            "module_group" => "ps.produit_selection_id",
            "module_limit" => 50,
        ];

        $this->table("back_module")
            ->insert($data)
            ->save();
    }

    public function down()
    {
        $this->execute("DELETE FROM back_module WHERE module_page = 'produit_gamme'");
    }
}
