<?php

namespace Controller;

use ClientCookie;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

/**
 * Class CookieController
 * @package Controller
 *
 * @Route("/cookie")
 */
class CookieController extends Controller
{
    /**
     * Renvoie le bandeaux cookie si besoin
     */
    public function show()
    {
        if ($this->getCookieConsent()) {
            return new Response('');
        }

        return $this->fetch('parts/cookie_consent.tpl');
    }

    /**
     * @Route("/accept", name = "cookie_accept", methods = {"POST"})
     */
    public function giveConsent()
    {
        $clientCookie = new ClientCookie();

        $clientId = null;

        $client = $this->getCurrentClient();
        if (!empty($client)) {
            $clientId = $client->client_id;
        }

        $clientCookie
            ->setClientCookieConsent(true)
            ->setClientId($clientId)
            ->setClientCookieIp($this->request->getClientIp())
            ->setBoutiqueId(\Boutique::getInstance()->id)
        ;

        $clientCookie->save();

        return new Response('');
    }

    /**
     * @return bool
     */
    public function getCookieConsent()
    {
        $clientCookie = new ClientCookie();
        $client = $this->getCurrentClient();
        $cookieConsent = false;
        if (!empty($client)) {
            $cookieConsent = !empty($client->getCookieConsent($client->client_id));
        }
        if (empty($cookieConsent)) {
            $cookieConsent = !empty($clientCookie->getByIp($this->request->getClientIp()));
        }
        return $cookieConsent;
    }

}