<?php


use Symfony\Component\Routing\Exception\InvalidParameterException;

final class Gamme extends Selection
{
    const SELECTION_TYPE = "gamme";

    protected $type = self::SELECTION_TYPE;

   public function __construct($id = null)
   {
       $this->leftJoin[] = ["gamme g", "g.gamme_id", "s.selection_id"];

       parent::__construct($id);
   }

    /**
     * @param int $id
     * @return Selection
     * @throws Exception
     */
    protected static function newSelf(int $id = null): Selection
    {
        return new Gamme($id);
    }

    public static function generateUrlFromBranch(array $treeSelection, $k = null)
    {
        if (is_null($k)) {
            $k = count($treeSelection) - 1;
        }
        $router = Application::getRouter()->getRouter();

        $paramUrl = array();
        $paramUrl['gamme_nom'] = Tools::parseURL($treeSelection[$k]->selection_nom_nom);
        $paramUrl['id'] = $treeSelection[$k]->selection_id;
        if (!empty($treeSelection[$k - 1])) {
            $paramUrl['parent_nom'] = Tools::parseURL($treeSelection[$k - 1]->selection_nom_nom);
        }
        if (!empty($treeSelection[$k - 2])) {
            $paramUrl['grand_parent_nom'] = Tools::parseURL($treeSelection[$k - 2]->selection_nom_nom);
        }

        try {
            $url = $router->generate('liste_gamme_' . ($k + 1), $paramUrl);
        } catch (InvalidParameterException $e) {
            $debugBar = Application::getDebugBar();
            if (!empty($debugBar)) {
                $debugBar['exceptions']->addException($e);
            }
            $url = '';
        }
        return $url;
    }
}