<?php

/**
 * Class Langue
 */
class Langue extends Model {
    const DEFAULT_LANGUE_ID = 1;
    const DEFAULT_LANGUE_INI = 'fr';

    protected $table = 'langue';

    public $id;
    public $nom;
    public $ini;
    public $img;
    public $img_site;

    public function __construct($id = null)
    {
        parent::__construct();

        if(!is_null($id)) {
            $this->load($id);
        }
    }

    /**
     * @param $id
     */
    public function load($id)
    {
        $theLangue = $this->get(array('langue_id' => $id));
        if(!empty($theLangue)) {
            $this->id = $theLangue[0]['langue_id'];
            $this->nom = $theLangue[0]['langue_nom'];
            $this->ini = $theLangue[0]['langue_ini'];
            $this->img = $theLangue[0]['langue_img'];
            $this->img_site = $theLangue[0]['langue_img_site'];
        }
    }

    /**
     * @param $isoCode
     * @return bool|Langue
     */
    static public function findByCodeISO($isoCode)
    {
        $langue = new Langue();
        $result = $langue->get(array('langue_ini' => $isoCode));

        if (!empty($result)) {
            $langue->load($result[0]['langue_id']);
            return $langue;
        }

        return false;
    }

    /**
     * @deprecated
     */
    public static function handle()
    {

        // TODO : a revoir si besoin

        $langue = new Langue();

        if(!empty($_SERVER['REDIRECT_STATUS']) && $_SERVER['REDIRECT_STATUS'] == 404) {

        }elseif(substr($_SERVER['REQUEST_URI'], 0, 5) == '/back') {
            // cas url BO, pas de check sur la langue
        } elseif (is_file($_SERVER['DOCUMENT_ROOT'] . DS . $_SERVER['REQUEST_URI'])) {
            // cas appel d'un fichier, on charge la langue en session, si pas de langue en session, langue par défaut de la boutique
            if(!empty($_SESSION['langue_ini'])) {
                $arrLangue = $langue->get(array('langue_ini' => $_SESSION['langue_ini']));
                if (!empty($arrLangue)) {
                    Boutique::getInstance()->getLangue()->load($arrLangue[0]['langue_id']);
                }
            }
        } elseif (empty($_GET['langue_ini'])) {
            // redir vers la page avec le prefixe qui va bien
            if(!empty($_SESSION['langue_ini'])) {
                $lgIni = $_SESSION['langue_ini'];
            } else {
                $lgIni = self::getHttpAcceptLanguage();
                $isExist = $langue->get(array('langue_ini' => $lgIni));
                if(empty($isExist)) {
                    $lgIni = self::DEFAULT_LANGUE_INI;
                }
                // $_SESSION['langue_ini'] = $lgIni;
            }

            $url = 'http://' . $_SERVER['HTTP_HOST'] . '/' . strtolower($lgIni) . $_SERVER['REQUEST_URI'];

            header('location: ' . $url);
            exit;
        } elseif (!empty($_GET['langue_ini']) && (empty($_SESSION['langue_ini']) || $_GET["langue_ini"] != $_SESSION['langue_ini'])) {

            $arrLangue = $langue->get(array('langue_ini' => $_GET['langue_ini']));
            if (!empty($arrLangue)) {
                Boutique::getInstance()->getLangue()->load($arrLangue[0]['langue_id']);
            } else {
                header('location: /');
                exit;
            }
        }
    }

    public static function getHttpAcceptLanguage()
    {
        $lang = Langue::DEFAULT_LANGUE_INI;

        if(!empty($_SERVER['HTTP_ACCEPT_LANGUAGE'])) {
            $listLang = explode(',', $_SERVER['HTTP_ACCEPT_LANGUAGE']);
            $lang = strtolower(substr(chop($listLang[0]), 0, 2));
        }

        return $lang;
    }
}