<?php

/**
 * Class Paiement
 * @property integer $paiement_id
 * @property string $paiement_image
 * @property string $paiement_type
 * @property string $paiement_class
 * @property string $paiement_nom_nom

 */
class Paiement extends Model {

    const PASSIF = 'passif';
    const ACTIF = 'actif';
    const PAYPAL_EXPRESS = 6;

    protected $table = 'paiement';

    // recuperation des paiements
    function get($formvars = array(), $champs = "") {

        $sql = "SELECT *, p.paiement_id";
        $sql.=" FROM (paiement p)";
        $sql.=" INNER JOIN paiement_boutique pb ON(p.paiement_id = pb.paiement_id AND pb.boutique_id = '".Boutique::getInstance()->id."')";
        $sql.=" LEFT JOIN paiement_nom pn on (p.paiement_id = pn.paiement_id AND pn.langue_id = '".Boutique::getInstance()->getLangue()->id."')";
        if (!empty($formvars['commande_id']))
            $sql.=" LEFT JOIN commande c ON (c.langue_id = pn.langue_id)";
        $sql.=" WHERE 1";
        if (empty($formvars['all'])) {
            $sql.=" AND p.actif_id = 1";
            $sql.=" AND pb.paiement_boutique_statut_id = 1";
        }

        if (!empty($formvars['paiement_id']))
            $sql.=" AND p.paiement_id = '" . $formvars['paiement_id'] . "'";
        if (!empty($formvars['commande_id']))
            $sql.=" AND c.commande_id = '" . $formvars['commande_id'] . "'";

        if (isset($formvars['prix']))
            $sql.=" AND p.paiement_total_debut <= '" . round($formvars['prix'], 2) . "' AND p.paiement_total_fin >= '" . round($formvars['prix'], 2) . "'";

        $sql.=" GROUP BY p.paiement_id";
        $sql.=" ORDER BY p.paiement_rang";

        if (empty($champs)) {
            return $this->sql->getAll($sql);
        } else {
            $result = $this->sql->getOne($sql);
            return $result[$champs];
        }
    }

    /*

    // ajout d'un mode de paiement
    function add($formvars = array()) {

        // id du mode de paiement, ou bien id de l'entite (id du BA, id du Cheque cadeaux
        $_SESSION['commande']['pay'][$_SESSION['nb_paiement']]['paiement_ref_id'] = $formvars['paiement_id'];
        // type du mode de paiement (BA : bon achat, CH pour cheque cadeau, vide sinon)
        $_SESSION['commande']['pay'][$_SESSION['nb_paiement']]['paiement_type'] = $formvars['paiement_type'];
        // nom du mode de paiement ou bien nom du bon achat ou du cheque cadeau
        $_SESSION['commande']['pay'][$_SESSION['nb_paiement']]['paiement_nom'] = $formvars['paiement_nom'];
        // si 1 reglement non recu (ex:cheque) si 2, reglement recu
        $_SESSION['commande']['pay'][$_SESSION['nb_paiement']]['paiement_statut_id'] = $formvars['paiement_statut_id'];
        // si 0 � integrer dans la table commande_paiement, si 1 paiement � int�grer dans la table commande_produit
        $_SESSION['commande']['pay'][$_SESSION['nb_paiement']]['paiement_in_cmd'] = $formvars['paiement_in_cmd'];

        // montant reel d'origine
        $_SESSION['commande']['pay'][$_SESSION['nb_paiement']]['paiement_total_ht'] = $formvars['paiement_total_ht'];
        $_SESSION['commande']['pay'][$_SESSION['nb_paiement']]['paiement_total_ttc'] = $formvars['paiement_total_ttc'];
        // montant affecte � la commande
        $_SESSION['commande']['pay'][$_SESSION['nb_paiement']]['paiement_montant_ht'] = $formvars['paiement_montant_ht'];

        if(!empty($formvars['paiement_nom_affichage']))
            $_SESSION['commande']['pay'][$_SESSION['nb_paiement']]['paiement_nom_affichage'] = $formvars['paiement_nom_affichage'];

        $_SESSION['commande']['pay'][$_SESSION['nb_paiement']]['paiement_montant_ttc'] = $formvars['paiement_montant_ttc'];
        // taxe
        $_SESSION['commande']['pay'][$_SESSION['nb_paiement']]['paiement_taxe'] = @$formvars['paiement_taxe'];
        $_SESSION['commande']['pay'][$_SESSION['nb_paiement']]['paiement_class'] = @$formvars['paiement_class'];

        $_SESSION['nb_paiement']++;
    }

    // ajoute le paiement choisi a la fin
    function addDefault($formvars = array()) {
        if (!empty($_SESSION['commande']['pay'])) {
            // on vire le dernier paiement par defaut si il existait
            foreach ($_SESSION['commande']['pay'] as $pay) {
                if (empty($pay['paiement_type'])) {
                    $this->delete(array('paiement_id' => $pay['paiement_ref_id'], 'paiement_type' => ''));
                }
            }
        }

        $arrPaiement['paiement_id'] = $formvars['paiement_id'];
        $arrPaiement['paiement_type'] = "";
        $arrPaiement['paiement_nom'] = $formvars['paiement_nom_nom'];
        if ($formvars['paiement_type'] == 'actif')
            $arrPaiement['paiement_statut_id'] = 2;
        else
            $arrPaiement['paiement_statut_id'] = 1;
        $arrPaiement['paiement_in_cmd'] = 0;
        $panier = new Panier;
        $aPayerTTC = $panier->aPayerTTC();
        $aPayerHT = $panier->aPayerHT();
        $arrPaiement['paiement_total_ht'] = $aPayerHT;
        $arrPaiement['paiement_total_ttc'] = $aPayerTTC;
        $arrPaiement['paiement_montant_ht'] = $aPayerHT;
        $arrPaiement['paiement_montant_ttc'] = $aPayerTTC;
        $this->add($arrPaiement);
    }


    // on cherche un paiement deja enregistre
    function find($formvars = array()) {

        if (!isset($_SESSION['commande']['pay']))
            return false;

        $pos = -1;
        foreach ($_SESSION['commande']['pay'] as $pay) {

            $pos++;

            if ($pay['paiement_ref_id'] == $formvars['paiement_id'] && $pay['paiement_type'] == $formvars['paiement_type']) {

                return $pos;
            }
        }

        return false;
    }

    // supprime un type de paiement
    function delete($formvars = array()) {

        $pos = $this->find(array('paiement_id' => $formvars['paiement_id'], 'paiement_type' => $formvars['paiement_type']));

        if ($pos !== false) {

            for ($i = $pos; $i < $_SESSION['nb_paiement'] - 1; $i++) {
                $_SESSION['commande']['pay'][$i] = $_SESSION['commande']['pay'][$i + 1];
            }
            unset($_SESSION['commande']['pay'][$_SESSION['nb_paiement'] - 1]);
            $_SESSION['nb_paiement']--;

            // on reaffecte les montants
            $this->reAffect();

            return true;
        }
        return false;
    }

    // suite a une suppression permet de reaffecter les montants
    function reAffect() {

        $panier = new Panier;

        foreach ($_SESSION['commande']['pay'] as &$pay) {

            if (!empty($pay['paiement_type'])) {

                $panierHT = $panier->aPayerHT();
                $panierTTC = $panier->aPayerTTC();

                if (($panierHT + $pay['paiement_montant_ht']) < $pay['paiement_montant_ht'] || ($panierTTC + $pay['paiement_montant_ttc']) < $pay['paiement_montant_ttc']) {
                    $pay['paiement_montant_ttc'] = $panierTTC;
                    $pay['paiement_montant_ht'] = $panierHT;
                } else {
                    $pay['paiement_montant_ttc'] = $pay['paiement_total_ttc'];
                    $pay['paiement_montant_ht'] = $pay['paiement_total_ht'];
                }
            }
        }
    }
    */

    // total ht des montants affect�s
    function totalHT($arrondi=false) {

        $totalHT = 0;

        if (isset($_SESSION['commande']['pay'])) {
            foreach ($_SESSION['commande']['pay'] as $pay) {
                if (!empty($pay['paiement_type'])) {
                    if ($arrondi == true)
                        $totalHT+= round($pay['paiement_montant_ht'], 2);
                    else
                        $totalHT+= $pay['paiement_montant_ht'];
                }
            }
        }
        return $totalHT;
    }

// total ttc des montants affect�s
    function totalTTC() {

        $totalTTC = 0;

        if (isset($_SESSION['commande']['pay'])) {
            foreach ($_SESSION['commande']['pay'] as $pay) {
                if (!empty($pay['paiement_type'])) {
                    $totalTTC+= $pay['paiement_montant_ttc'];
                }
            }
        }

        return $totalTTC;
    }

    // renvoie le surplusTTC des paiements
    function surPlusTTC($arrondi=false) {

        $surPlus = 0;
        if (!empty($_SESSION['commande']['pay'])) {
            foreach ($_SESSION['commande']['pay'] as $pay) {

                if (!empty($pay['paiement_type'])) {
                    $surPlus+=$pay['paiement_total_ttc'] - $pay['paiement_montant_ttc'];
                }
            }
        }
        return $surPlus;
    }

    // renvoie le surplusTTC des paiements
    function surPlusHT() {

        $surPlus = 0;
        if (!empty($_SESSION['commande']['pay'])) {
            foreach ($_SESSION['commande']['pay'] as $pay) {

                if (!empty($pay['paiement_type'])) {
                    $surPlus+=$pay['paiement_total_ht'] - $pay['paiement_montant_ht'];
                }
            }
        }
        return $surPlus;
    }
}