{extends file="layout/layout.tpl"}


{block name="content"}
    <!-- listing.tpl -->

    <div class="listingPage" id="listingPage">
        <div class="hidden-xs">
            {Breadcrumb::getInstance()->render()}
        </div>
        <div class="container">
            <div class="row">
                <div class="col-xs-12">

                    {* //LISTING - Title & Description *}
                    <div class="listingIntro">
                        <div class="listingTitle">
                            <h1 class="titleLvl1">
                                {$titre}
                            </h1>
                            {if isset($image_listing)}
                                {image src=$image_listing  class="imgListingBg hidden-xs" width="1150" height="300"}
                            {/if}
                        </div>

                        {* //DESCRIPTION *}
                        <div class="listingDesc">
                            <div class="description">
                                <div class="descriptionBody">
                                    <p>
                                        {$desc}
                                    </p>
                                </div>
                                <div class="descriptionFooter hidden">
                                    <div class="descriptionFooterContainer {if !empty($arrRows)}multiLink{/if}">
                                        <a href="#" class="mainLink descriptionFooterLink" data-toggle="button" aria-pressed="false">
                                            <span class="textReadMore">{txt value="Lire la suite"}</span>
                                            <span class="textReadLess hidden">{txt value="Masquer"}</span>
                                        </a>

                                        {if !empty($arrRows)}
                                            <a href="#fullDescription" class="mainLink smoothscroll">
                                                {txt value="Voir le descriptif"}
                                            </a>
                                        {/if}
                                    </div>
                                </div>
                            </div>
                        </div>
                        {* DESCRIPTION// *}
                    </div>
                    {* LISTING - Title & Description// *}

                </div>
                <div class="col-xs-6 col-sm-4 col-md-3">

                    {* //FILTER *}
                    <div class="filter">
                        <div class="filterHeader">
                            <button type="button" class="btn btnFilter btnShutterOpen" data-target="shutterFilter" data-toggle="button" aria-pressed="false" autocomplete="off">
                                <span class="btnIcon">
                                    {include file="icons/filter.tpl"}
                                </span>
                                <span class="btnText">{txt value="Filtrer"}</span>
                            </button>
                        </div>
                        <div class="filterBody hidden-xs">
                            {* //FILTER - Selection *}
                            <div class="filterSelection">
                                <div class="filterSelectionBody clearfix">

                                </div>
                                <div class="clearfix"></div>
                                <div class="filterSelectionFooter hidden-xs" style="display: none;">
                                    <a href="{$urlPage}">{txt value='Tout effacer'}</a>
                                </div>
                            </div>
                            {* FILTER - Selection// *}
                            {include file="listing/filtres/filtres.tpl"}
                        </div>
                        <div class="filterBody hidden-lg hidden-md hidden-sm">
                            {* //FILTER - Selection *}
                            <div class="filterSelection">
                                <div class="filterSelectionBody clearfix">

                                </div>
                                {*<div class="clearfix"></div>*}
                                <div class="filterSelectionFooter hidden-xs" style="display: none;">
                                    <a href="{$urlPage}">{txt value='Tout effacer'}</a>
                                </div>
                            </div>
                            {* FILTER - Selection// *}
                        </div>
                    </div>
                    {* FILTER// *}

                </div>
                <div class="col-xs-6 col-sm-2 col-sm-push-6 col-md-push-7 col-lg-3 col-lg-push-6">
                    {* //TRI *}
                    {include file='listing/tri.tpl' top=true}
                    {* TRI// *}
                </div>
                <div class="col-xs-12 col-sm-8 col-md-9">
                    <div class="wrapProductListing" id="wrapProductListing">

                        {* //PRODUCT - Count *}
                        <div class="productCount">
                            <span id="countProduits">{$countProduct|default:0}</span> {txt value="produit(s) trouvé(s)"}
                        </div>
                        {* PRODUCT - Count// *}

                        <div class="row">
                            {include file="listing/list_product.tpl"}
                        </div>

                    </div>
                </div>
            </div>

            {* //LISTING - Footer *}
            <div class="listingFooter">
                <div class="row">
                    <div class="col-xs-12">

                        {if !empty($pages)}
                            {* //PRODUCT - Count *}
                            <div class="productCount">
                                <span id="nb-current-product">{count($arrProd)}</span> {txt value="sur"} {$countProduct|default:0} {txt value="produits"}
                            </div>
                            {* PRODUCT - Count// *}

                            <button class="btn btnSecondary wide" type="button" data-role="pagination" data-url="{$pages.url}">
                                {txt value="Charger plus de produits"}
                            </button>
                        {/if}
                    </div>
                </div>
            </div>

            {* LISTING - Footer// *}
        </div>
    </div>

{/block}
{block name="fixedmobile"}
    {include file="listing/filtres/filtres.tpl" class="mobile"}
{/block}


{block name="script-js"}
    <script type="text/javascript">
        $(document).ready(function(){

            var htmlInit = "";
            $('input[type=checkbox]:checked').each(function (index) {
                var carac_nom_nom = $(this).attr("data-carac-nom");
                var carac_valeur = $(this).attr("data-carac-valeur");
                var parent_id = $(this).attr('id');
                htmlInit = htmlInit +  "<a href='#' class='btnFilterSelection' data-parent-id='#"+parent_id+"'>"+carac_nom_nom+" : "+carac_valeur+"</a>";
            });
            $("div.filterSelectionBody.clearfix").html(htmlInit);
            if(htmlInit != ""){
                $("div.filterSelectionFooter.hidden-xs").show();
            }

            $('.triName').on('click',function(e){
                e.preventDefault();
                $('.triName').removeClass('active');
                $(this).addClass("active");
                updateProductList(null,null,$(this).data('order'));

                if (window.matchMedia("(max-width: 767px)").matches) {
                    $("#shutterTri").toggleClass('open');
                } else {
                    $('.triList.list-unstyled').toggleClass('open');
                }
            });


            // filtres
            $("input[type=checkbox]").on('change',function (event) {
                if (!window.matchMedia("(max-width: 767px)").matches) {
                    updateProductList();
                }
            });

            $('button#applyFilters').on('click',function (event) {
                event.preventDefault();
                updateProductList();
                $('div#shutterFilter').removeClass('open');
            });

            $(document).on('click', 'button[data-role="pagination"]', function(event){
                event.preventDefault();
                var url = $(this).data('url');

                $.get(url, function(data) {

                    $('#wrapProductListing .row').append(data.produits);

                    if (data.pagination.url == undefined) {
                        $('.listingFooter').hide();
                    } else {
                        $("#nb-current-product").html(data.pagination.nb_product);
                        $('button[data-role="pagination"]').data('url', data.pagination.url);
                        $('.listingFooter').show();
                    }

                    if (data.urlState) {
                        window.history.replaceState(null, null, data.urlState);
                    }

                }, 'json');
            });

            // $(document).on('change', 'select[name=limit], select[name=order]', function(event){
            //     console.log($(this).parents('form#tri'));
            //     $(this).parents('form#tri').submit();
            // });

            $(document).on('submit', 'form[name="add-panier"], .add-panier', function(event){
                event.preventDefault();
                new Panier().add(jQuery(this));
            });

            //FILTER - Brands
            var $marqueList = $('#marqueList');
            var marqueList_height = parseInt($('#marqueList').css('maxHeight'));

            if ( $marqueList.find('.filterCategoryItem').length > 3 ) {
                var simplebarMarqueList = new SimpleBar(document.getElementById('marqueList'));
            }

            $('#marqueFilter').on('input',function (e) {
                var input = $('#marqueFilter').val();
                $("#marqueList .filterCategoryItem").each(function (i) {
                    if($(this).find("span.text").text().toUpperCase().search(input.toUpperCase()) > -1){
                        $(this).removeClass('hidden');
                    } else {
                        $(this).addClass('hidden');
                    }
                });
                if ( $('#marqueList').height() < marqueList_height ) {
                    $marqueList.addClass('simplebarDisabled');
                } else {
                    $marqueList.removeClass('simplebarDisabled');
                }
                if ( $('#marqueList').height() == 0 ) {
                    $marqueList.find('.filterCategoryItem.resultNo').removeClass('hidden');
                } else {
                    $marqueList.find('.filterCategoryItem.resultNo').addClass('hidden');
                }
            });

            {if !empty($arrProd)}
                //FILTER - Price - Slider
                var filterPriceSlider = $(".filterPriceSlider"),
                    prix_range = $("#prix_range");
                    filterPriceSlider.ionRangeSlider({
                        hide_min_max: true,
                        keyboard: true,

                        min: {$lepluspetitprix},
                        max: {$leplusgrandprix},

                        from: parseInt(prix_range.find('input[name="prix_min"]').val()),
                        to: parseInt(prix_range.find('input[name="prix_max"]').val()),
                        type: 'double',
                        step: 1,
                        postfix: " €",
                        grid: false,
                        onFinish: function(data){
                            // prix_range.find('input[name="prix_min"]').val(data.from);

                            $('input[name="prix_min"]').val(data.from);
                            $('input[name="prix_max"]').val(data.to);

                            // prix_range.find('input[name="prix_max"]').val(data.to);

                            if (!window.matchMedia("(max-width: 767px)").matches) {
                                updateProductList(data.from,data.to);
                            }

                        }
                    });
            {/if}
            function updateProductList(prix_min = null,prix_max = null, order = null) {
                var features = "";
                var html = "";
                $('input[type=checkbox]:checked').each(function (index) {
                    var carac_nom_nom = $(this).attr("data-carac-nom");
                    var carac_valeur = $(this).attr("data-carac-valeur");
                    var parent_id = $(this).attr('id');
                    html = html +  "<a href='#' class='btnFilterSelection' data-parent-id='#"+parent_id+"'>"+carac_nom_nom+" : "+carac_valeur+"</a>";
                    if(index >= 1){
                        features = features +","+ $(this).val();
                    } else {
                        features = features + $(this).val();
                    }
                });

                $("div.filterSelectionBody.clearfix").html(html);

                {* Filtre prix*}
                if(prix_min == null) {
                    prix_min = $('input[name="prix_min"]').val();
                }
                if(prix_max == null) {
                    prix_max = $('input[name="prix_max"]').val();
                }


                {* Pour le texte "Tout effacer"*}
                if(html !== ""){
                    $("div.filterSelectionFooter.hidden-xs").show();
                    $("a.btnFilterSelection").on('click',function (e) {
                        e.preventDefault();
                        $($(this).attr('data-parent-id')).attr('checked',false);
                        updateProductList();
                    });
                } else {
                    $("div.filterSelectionFooter.hidden-xs").hide();
                }
                var dataForm = 'prix_min='+prix_min+'&prix_max='+prix_max;

                if(order != null){
                    dataForm += "&order="+order;
                }
                var motclef = "";
                {if !empty($motclef)}
                    motclef = '&motclef={$motclef}';
                {else}
                    motclef = "";
                {/if}

            }

        });
    </script>
{/block}